//	Microworks ObjectMate  2.6
//
//  ObjectMate Interface Library
//
//	Copyright 1992-94 Microworks Sydney, Australia.
//
//  SFX200.H

#if !defined(__SFX_SFX200_H)
 #define __SFX_SFX200_H

#ifndef RC_INVOKED
 #pragma warn -nak
#endif

#if !defined(WORKSHOP_INVOKED)
 #if !defined(__WINDOWS_H)
  #include <windows.h>
 #endif
#endif

#if !defined(EXPORT)
 #define EXPORT _export
#endif

#if !defined(__FLAT__) && !defined(WIN32)
 #define SFXAPI FAR EXPORT PASCAL
#else
 #define SFXAPI APIENTRY EXPORT
#endif

//	Border styles

#define	BD_RECESSED         0x01
#define	BD_RAISED           0x02

//	Extra combo box style flag. Specifies an SFX combo box with no 3D border. 

#define CBS_NO3DBORDER	    0x8000

//	Extra WM_CTLCOLOR value that identifies an SFX combo box

#define	CTLCOLOR_COMBOBOX   0x0F

//	Common dialog box templates

#define	DLG_COLOR           1
#define	DLG_EXCOLOR         2
#define	DLG_OPENSAVE        3
#define	DLG_EXOPENSAVE   	4
#define	DLG_PRINT           5
#define	DLG_PRINTSETUP      6
#define	DLG_FIND            7
#define	DLG_REPLACE         8
#define	DLG_FONT            9
#define DLG_EXFONT          10
#define	DLG_OPENDIR         11

//	Old Common dialog box template Id's for backward compatibility

#define	DLG_CHOOSECOLOR     1
#define	DLG_EXCHOOSECOLOR   2

//	Extends the standard button Id's form 7 to 11

#if !defined(WORKSHOP_INVOKED)
 #define IDHELP             8
#else
 #define IDHELP             998
#endif
#define	IDBROWSE            9
#define	IDGO                10
#define	IDSTOP              11

//	Turns on and off edit mode in a list edit box. wParam and lParam must be zero.

#define LB_LISTEDITON       (WM_USER + 0X1001)
#define LB_LISTEDITOFF      (WM_USER + 0X1002)

//	Extra list box styles

#define	LBS_NO3DBORDER      0x2000	//	No 3D Border
#define	LBS_SFXLISTEDIT     0x4000	//	List edit box
#define	LBS_SFXMULTIPLESEL  0x8000	//	Right mouse button only multiple selection list box

//	Extra message box button combinations

#define	MB_GO               0x000A
#define	MB_GOSTOP           0x000B
#define	MB_OKCANCELHELP     0x000C
#define	MB_YESNOHELP        0x000D

//	Button style flags

#define	MBS_PUSHBUTTON      BS_PUSHBUTTON
#define MBS_CHECKBOX        BS_CHECKBOX
#define MBS_AUTOCHECKBOX    BS_AUTOCHECKBOX
#define MBS_RADIOBUTTON     BS_RADIOBUTTON
#define MBS_3STATE          BS_3STATE
#define MBS_AUTO3STATE      BS_AUTO3STATE
#define MBS_AUTORADIOBUTTON BS_AUTORADIOBUTTON
#define MBS_ICONBUTTON      0x000E
#define	MBS_DEFFONT         0x0010
#define MBS_LEFTTEXT        0X0020
#define	MBS_RAISEDTEXT	    0x0040
#define	MBS_RECESSEDTEXT	0x0080
#define	MBS_RED      		0x0100
#define	MBS_LIME            0X0200
#define	MBS_BLUE            0X0300
#define	MBS_MAGENTA         0X0400
#define	MBS_MAROON          0X0500
#define	MBS_GREEN           0X0600
#define	MBS_NAVY            0X0700
#define	MBS_PURPLE          0X0800
#define	MBS_YELLOW          0X0900
#define	MBS_FLUSH    		0x1000
#define	MBS_RAISED          0x1000
#define	MBS_BITMAP          0x2000
#define	MBS_BITMAPBUTTON    0x4000
#define	MBS_TEXTBUTTON      0x8000

//	Percent style flags

#define	MPS_TOP             0x0001
#define	MPS_BOTTOM          0x0002
#define	MPS_RED             0x0010
#define	MPS_LIME            0x0020
#define	MPS_BLUE            0x0030
#define	MPS_MAGENTA         0x0040
#define	MPS_MAROON          0x0050
#define	MPS_GREEN           0x0060
#define	MPS_NAVY            0x0070
#define	MPS_PURPLE          0x0080

//	Scroll bar style flags

#define	MSB_HORZ            0x0000
#define	MSB_VERT            0x0001
#define	MSB_TOPLEFT         0x0010
#define	MSB_BOTTOMRIGHT     0x0020

//	Shade style flags

#define	MSH_LEFT            0x0000
#define	MSH_LTGRAY          0x0000
#define	MSH_RECT            0x0000
#define	MSH_FRAME           0x0001
#define	MSH_VLINE           0x0002
#define	MSH_HLINE           0x0004
#define	MSH_RECESSED        0x0008
#define	MSH_RAISED          0x0010
#define	MSH_BORSTYLE        0x0020
#define	MSH_CENTER          0x0040
#define	MSH_RIGHT           0x0080
#define	MSH_RECESSEDTEXT	0x0100
#define	MSH_RAISEDTEXT      0x0200
#define	MSH_DEFFONT         0x0400
#define	MSH_NOPREFIX        0x0800
#define	MSH_STEEL           0x1000
#define	MSH_GLAZE           0x2000
#define	MSH_RED             0x3000
#define	MSH_LIME            0x4000
#define	MSH_BLUE            0x5000
#define	MSH_MAGENTA         0x6000
#define	MSH_MAROON          0x7000
#define	MSH_GREEN           0x8000
#define	MSH_NAVY            0x9000
#define	MSH_PURPLE          0xA000
#define	MSH_BLACK           0xB000
#define	MSH_WINCOLOR        0xC000
#define	MSH_TRANSPARENT     0xD000
#define	MSH_VHUMP           (MSH_VLINE | MSH_RAISED)
#define	MSH_VDIP            (MSH_VLINE | MSH_RECESSED)
#define	MSH_HHUMP           (MSH_HLINE | MSH_RAISED)
#define	MSH_HDIP            (MSH_HLINE | MSH_RECESSED)
#define	MSH_RAISEDFRAME     (MSH_RAISED | MSH_FRAME)
#define	MSH_RECESSEDFRAME   (MSH_RECESSED | MSH_FRAME)

//	Static style flags

#define	MSS_TEXT            0x0000
#define	MSS_TOP             0x0000
#define	MSS_LEFT            0x0000
#define	MSS_RECESSEDTEXT	0x0001
#define	MSS_RAISEDTEXT	    0x0002
#define	MSS_SHADOWTEXT	    0x0003
#define	MSS_BITMAP          0x0004
#define	MSS_BITMAPWINDOW    0x0005
#define	MSS_HCENTER         0x0010
#define	MSS_RIGHT           0x0020
#define	MSS_BOTTOM          0x0040
#define	MSS_VCENTER         0x0080
#define	MSS_RECESSED        0x0100
#define	MSS_RAISED          0x0200
#define	MSS_FRAME           0x0400
#define	MSS_WORDWRAP		0x0800
#define	MSS_SINGLELINE      0x1000
#define	MSS_NOPREFIX        0x2000
#define	MSS_SFXPAINT        0x2000
#define	MSS_EXPANDTABS      0x4000
#define MSS_DEFFONT         0X8000
#define	MSS_CENTER          (MSS_VCENTER | MSS_HCENTER)
#define	MSS_CENTERBITMAP    (MSS_BITMAPWINDOW | MSS_CENTER)
#define	MSS_RAISEDFRAME     (MSS_RAISED | MSS_FRAME)
#define	MSS_RECESSEDFRAME   (MSS_RECESSED | MSS_FRAME)

//  Offset to the Static control's window handle in an aligned toolar or status bar

#define MTB_WNDSTATIC       2

//	Offset to the text string containing the toolbar title and current button ID's

#define MTB_WNDTEXT         4

//	Toolbar style flags

#define	MTB_ROW1            0x0001
#define	MTB_ROW2            0x0002
#define	MTB_ROW3            0x0003
#define	MTB_ROW4            0x0004
#define	MTB_ROW5            0x0005
#define	MTB_ROW6            0x0006
#define	MTB_ROW7            0x0007
#define	MTB_ROW8            0x0008
#define	MTB_ROW9            0x0009
#define	MTB_ROW10           0x000A
#define	MTB_ROW11           0x000B
#define	MTB_ROW12           0x000C
#define	MTB_ROW13           0x000D
#define	MTB_ROW14           0x000E
#define	MTB_ROW15           0x000F
#define	MTB_COLUMN1         0x0010
#define	MTB_COLUMN2         0x0020
#define	MTB_COLUMN3         0x0030
#define	MTB_COLUMN4         0x0040
#define	MTB_COLUMN5         0x0050
#define	MTB_COLUMN6         0x0060
#define	MTB_COLUMN7         0x0070
#define	MTB_COLUMN8         0x0080
#define	MTB_COLUMN9         0x0090
#define	MTB_COLUMN10        0x00A0
#define	MTB_COLUMN11        0x00B0
#define	MTB_COLUMN12        0x00C0
#define	MTB_COLUMN13        0x00D0
#define	MTB_COLUMN14        0x00E0
#define	MTB_COLUMN15        0x00F0
#define	MTB_TOP             0x0100
#define	MTB_LEFT            0x0200
#define	MTB_RIGHT           0x0300
#define	MTB_BOTTOM          0x0400
#define	MTB_FLOAT           0x0500
#define	MTB_STATUS          0x0600
#define	MTB_3DFRAME         0x1000
#define	MTB_FLUSH           0x2000
#define	MTB_RADIO           0x4000
#define	MTB_BITMAPBUTTON    0x8000

//	Window style flags

#define	MWS_SFXCAPTION      0x0200
#define	MWS_FRAMEDCLIENT    0x0400
#define	MWS_RAISEDCLIENT    0x0800
#define	MWS_GRAY            0x0800
#define	MWS_3DFRAME         0x1000
#define	MWS_3DGRAY          0x1000
#define	MWS_SFXFRAME        0x2000
#define	MWS_GLAZE           0x4000
#define	MWS_STEEL           0x8000
#define	MWS_3DGLAZE         (MWS_GLAZE | MWS_3DFRAME)
#define	MWS_3DSTEEL         (MWS_STEEL | MWS_3DFRAME)
#define	MWS_FRAMED3DFRAME   (MWS_3DFRAME | MWS_FRAMEDCLIENT)
#define	MWS_FRAMED3DGLAZE   (MWS_3DGLAZE | MWS_FRAMEDCLIENT)
#define	MWS_FRAMED3DSTEEL   (MWS_3DSTEEL | MWS_FRAMEDCLIENT)
#define	MWS_RAISED3DFRAME   (MWS_3DFRAME | MWS_RAISEDCLIENT)
#define	MWS_RAISED3DGLAZE   (MWS_3DGLAZE | MWS_RAISEDCLIENT)
#define	MWS_RAISED3DSTEEL   (MWS_3DSTEEL | MWS_RAISEDCLIENT)

//	Old window style flags included for backward compatiblity

#define	MWS_FLAT3DFRAME     MWS_3DFRAME
#define	MWS_FLAT3DGLAZE     MWS_3DGLAZE
#define	MWS_FLAT3DSTEEL	    MWS_3DSTEEL

//	Hide menu item identifier on toolbar system menu

#define SC_HIDE             0xFF00

//	High order word values identifying the control sending a WM_SFXCTLCOLOR message
#define	SFXCTLCOLOR_BUTTON  0x10
#define	SFXCTLCOLOR_CHECK   0x11
#define	SFXCTLCOLOR_COMBO   0x12
#define	SFXCTLCOLOR_DLG     0x13
#define	SFXCTLCOLOR_RADIO   0x14
#define	SFXCTLCOLOR_SHADE   0x15
#define	SFXCTLCOLOR_STATIC  0x16
#define	SFXCTLCOLOR_PERCENT 0x17

// SFX200.DLL version 2.6

#define	SFXVERSION          0x0260

//	Undocumented window message posted in a window's message queue when a menu is cancelled.
//	If the closing menu is a poup menu wParam is TRUE. Otherwise it's FALSE. 

#define WM_EXITMENULOOP     0x0212

//	Private messages

#define	WM_ALIGNTOOLBAR     (WM_USER + 0x1003)
#define	WM_DRAWPERCENT      (WM_USER + 0x1004)
#define	WM_GETCHECK         (WM_USER + 0x1005)
#define WM_RESETPERCENT     (WM_USER + 0x1006)
#define	WM_SETBITMAP        (WM_USER + 0x1007)
#define	WM_SETBRUSH         (WM_USER + 0x1008)
#define	WM_SETCHECK         (WM_USER + 0x1009)
#define	WM_SETPEN           (WM_USER + 0x100A)
#define	WM_SFXCTLCOLOR	    (WM_USER + 0x100B)
#define	WM_SFXAPPLYCOLOR    (WM_USER + 0x100C)
#define	WM_SFXAPPLYFONT     (WM_USER + 0x100D)
#define	WM_SFXHELP     	    (WM_USER + 0x100E)
#define	WM_SFXINITDIALOG    (WM_USER + 0x100F)

//	SFX stock object values used in the GetSFXObject function

#define	GLAZE_BRUSH         1
#define	STEEL_BRUSH         2
#define	RED_BRUSH           3
#define	LIME_BRUSH          4
#define	BLUE_BRUSH          5
#define	MAGENTA_BRUSH       6
#define	MAROON_BRUSH        7
#define	GREEN_BRUSH         8
#define	NAVY_BRUSH          9
#define	PURPLE_BRUSH        10
#define	FINE_FONT           11
#define	BOLD_FONT           12
#define	RED_PEN             13
#define	BLUE_PEN            14
#define	GREEN_PEN           15
#define	MAROON_PEN          16
#define	NAVY_PEN            17
#define	PURPLE_PEN          18
#define	YELLOW_BRUSH        19
#define	SYSTEM_FINE_FONT    20

#if defined(__cplusplus)
 extern "C" {
#endif	//

//	Functions exported by SFX200.DLL

extern void SFXAPI AlignBrush
(
	HWND   hWnd,
	HDC    hDC,
	HBRUSH hBrush
);

extern void SFXAPI BlackFrame
(
	HDC hDC,
	int X1,
	int Y1,
	int X2,
	int Y2
);

extern void SFXAPI CenterWindow
(
	HWND hWndParent,
	HWND hWnd
);

extern RECT far* SFXAPI ChildToParentRect
(
	HWND hWnd
);

extern void SFXAPI DrawBorder
(
	HDC  hDC,
	int  x,
	int  y,
	int  width,
	int  height,
	UINT style = BD_RECESSED
);

extern void SFXAPI Draw3DBorder
(
	HDC  hDC,
	int  x,
	int  y,
	int  width,
	int  height,
	UINT style = BD_RECESSED
);

extern BOOL SFXAPI EraseObject
(
	HGDIOBJ hObject
);

extern HFONT SFXAPI GetSFXCtrlFont
(
	HWND hWnd
);

extern HGDIOBJ SFXAPI GetSFXObject
(
	int index
);

extern char far* SFXAPI GetSFXTemplate
(
	const char far* className,
	UINT            templateType
);                                                                   

extern int SFXAPI GetSFXTemplateId
(
	const char far* className,
	UINT            templateType
);

extern BOOL SFXAPI IsNCActive
(
	HWND hWnd
);

extern BOOL SFXAPI PtInClient
(
	HWND hWnd,
	POINT point
);

extern BOOL SFXAPI PtInWindow
(
	HWND hWnd,
	POINT point
);

extern BOOL SFXAPI SFXChooseColor
(
	HWND          hwndParent,
	COLORREF far* rgbColor,
	DWORD         flags = 0,
	int           templateId = 0,
	BOOL          center = FALSE,
	COLORREF far* customColors = 0
);

extern BOOL SFXAPI SFXChooseFont
(
	HWND          hwndParent,
	LOGFONT far*  logFont,
	DWORD         flags = 0,
	int           templateId = 0,
	BOOL          center = FALSE,
	COLORREF far* rgbColor = 0
);

extern LRESULT SFXAPI SFXDefDlgProc
(
	HWND   hDlg,
	UINT   msg,
	WPARAM wParam,
	LPARAM lParam
);

extern LRESULT SFXAPI SFXDefWindowProc
(
	HWND   hWnd,
	UINT   msg,
	WPARAM wParam,
	LPARAM lParam
);

extern LRESULT SFXAPI SFXDefFrameProc
(
	HWND   hWnd,
	HWND   hWndClient,
	UINT   msg,
	WPARAM wParam,
	LPARAM lParam
);

extern LRESULT SFXAPI SFXDefMDIChildProc
(
	HWND   hWnd,
	UINT   msg,
	WPARAM wParam,
	LPARAM lParam
);

extern int SFXAPI SFXDirBox
(
	HWND            hWndParent,
	const char far* caption,
	char far*       dir,
	UINT            flags = 0,
	UINT            style = 0
);

extern int SFXAPI SFXMsgBox
(
	HWND            hWndParent,
	const char far* text,
	const char far* caption,
	UINT            type = 0,
	UINT            style = 0
);

extern int SFXAPI SFXInputBox
(
	HWND            hWndParent,
	const char far* caption,
	const char far* prompt,
	char far*       text,
	UINT            maxCount = 144,
	UINT            style = 0
);

extern BOOL SFXAPI SFXOpenDir
(
	HWND            hWndParent,
	char far*       dir,
	const char far* title = "",
	DWORD           flags = 0,
	int             templateId = 0,
	BOOL            center = FALSE
);

extern BOOL SFXAPI SFXOpenFile
(
	HWND            hwndParent,
	char far*       file,
	const char far* filters,
	DWORD           flags = 0,
	int             templateId = 0,
	BOOL            center = FALSE,
	const char far* title = "",
	DWORD far*      filterIndex = 0,
	const char far* defExt = ""
);

extern BOOL SFXAPI SFXSaveFile
(
	HWND            hwndParent,
	char far*       file,
	const char far* filters,
	DWORD           flags = 0,
	int             templateId = 0,
	BOOL            center = FALSE,
	const char far* title = "",
	DWORD far*      filterIndex = 0,
	const char far* defExt = ""
);

extern HINSTANCE SFXAPI GetSFXInstance(void);

extern UINT SFXAPI GetSFXVersion(void);

#if defined(__cplusplus)
 }
#endif
                                             
#ifndef RC_INVOKED
 #pragma warn .nak
#endif

#endif	//	__SFX_SFX200_H




